



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>JavaScript权威设计--事件冒泡，捕获，事件句柄，事件源，事件对象(简要学习笔记十八)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">JavaScript权威设计--事件冒泡，捕获，事件句柄，事件源，事件对象(简要学习笔记十八)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-25 23:25:22 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>1.事件冒泡与事件捕获</strong></p>
<div><strong>2.事件与事件句柄</strong></div>
<div>&nbsp;</div>
<div><strong>3.事件委托</strong>：利用事件的冒泡技术。子元素的事件最终会冒泡到父元素直到跟节点。事件监听会分析从子元素冒泡上来的事件。</div>
<div><strong>事件委托的好处：</strong></div>
<div>&nbsp; &nbsp; 1.每个函数都是对象，都会占用内存，内存中对象越多，性能越差。</div>
<div>&nbsp; &nbsp; 2.必须事先指定所有事件处理程序而导致的DOM访问次数，会延迟整个页面的交互就绪时间。</div>
<div><strong>怎样处理由于事件较多引起的性能差：</strong></div>
<div>1.采用事件委托技术，限制简历的连接数量</div>
<div>2.在不需要的时候移除事件处理程序</div>
<div>例子：</div>
<div>html:</div>
<div>
<div>
<pre class="prettyprint linenums">&lt;div id="myDiv"&gt;<br />
    &lt;input type="button" value="点我" id="myBtn"&gt;<br />
&lt;/div&gt;</pre>
</div>
</div>
<div>&nbsp;</div>
<div>js:</div>
<div>
<div>
<pre class="prettyprint linenums">var btn=document.getElementById("myBtn");<br />
btn.onclick=function(){

    document.getElementById("myDiv").innerHTML="Progress...";<br />
}</pre>
</div>
</div>
<div>注意：<strong>通过设置innerHTML可以把按钮移走，但是事件处理程序依旧与按钮保持着事件处理程序的引用都保存在内存中。</strong></div>
<div>&nbsp; &nbsp; 所以最好手动移除：</div>
<div>&nbsp;</div>
<div>
<div>
<pre class="prettyprint linenums">var btn=document.getElementById("myBtn");<br />
btn.onclick=function(){<br />
    btn.onclick=null;//移除事件处理程序<br />
    document.getElementById("myDiv").innerHTML="Progress...";<br />
}</pre>
</div>
</div>
<div>&nbsp;</div>
<div><strong>4.事件对象与事件源</strong></div>
<div>
<div>
<pre class="prettyprint linenums">function eventHandler(e){<br />
    //获取事件对象<br />
e = e || window.event;//IE和Chrome下是window.event FF下是e<br />
    //获取事件源<br />
var target = e.target || e.srcElement;//IE和Chrome下是srcElement FF下是target<br />
}</pre>
</div>
<p><strong>5.取消事件默认行为</strong></div>
<div>
<div>
<pre class="prettyprint linenums">function eventHandler(e) {<br />
    e = e || window.event;<br />
    // 防止默认行为<br />
    if (e.preventDefault) {<br />
        e.preventDefault();//IE以外<br />
    } else {<br />
        e.returnValue = false;//IE<br />
        //注意：这个地方是无法用return false代替的<br />
        //return false只能取消元素<br />
    }<br />
}</pre>
</div>
<p><strong>6.阻止事件冒泡</strong></div>
<div>
<div>
<pre class="prettyprint linenums">function myParagraphEventHandler(e) {<br />
    e = e || window.event;<br />
    if (e.stopPropagation) {<br />
        e.stopPropagation();//IE以外<br />
    } else {<br />
        e.cancelBubble = true;//IE<br />
    }<br />
}</pre>
</div>
</div>
<div><strong>7.event与target</strong></div>
<div>event：代表了包含了事件的所有状态。</div>
<div>target:触发事件的元素。</div>
<div>currentTarget:事件绑定的元素。</div>
<div>注意着两者的区别。</div>
<p>html:</p>
<div>
<div>
<pre class="prettyprint linenums">&lt;ul id="ulT"&gt;<br />
&lt;li class="item1"&gt;fsda&lt;/li&gt;<br />
&lt;li class="item2"&gt;ewre&lt;/li&gt;<br />
&lt;li class="item3"&gt;qewe&lt;/li&gt;<br />
&lt;li class="item4"&gt;xvc&lt;/li&gt;<br />
&lt;li class="item5"&gt;134&lt;/li&gt;<br />
&lt;/ul&gt;</pre>
</div>
<pre class="prettyprint linenums">js:</pre>
<div>
<pre class="prettyprint linenums">document.getElementById("ulT").onclick = function  (event) {<br />
    console.log(event.target);<br />
    console.log(event.currentTarget);<br />
}</pre>
</div>
</div>
<div>&nbsp;</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zy1jn9.html">简单正则匹配QQ邮箱</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwoyyr9.html">&lbrack;leetcode&rsqb; 题型整理之字符串处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdxde08.html">Javascript之旅&mdash;&mdash;第三站：几个需要注意的运算符</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e2zlz8.html">PHP ob系列函数详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdeood09.html">VA中修改函数注释</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1w3039.html">hdu 4635 Strongly connected   强连通</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyozdk9.html">1102&colon; 零起点学算法09&mdash;&mdash;继续练习简单的输入和计算（a-b&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv13n1xq.html">Ubuntu 共享 转载</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj7zo09.html">VUE2&period;0 elemenui-ui 2&period;0&period;X 封装 省市区三级</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz4gjw8.html">access窗体最大化到软件大小</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwm7my8.html">python数据结构与算法第五天【顺序表】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllk3gkq.html">我的IT之路这样走过</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rg6k08.html">JavaScript小细节点罗列（2）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppg0449.html">android学习-IPC机制之ACtivity绑定Service通信</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kllrlq.html">Linux之RPM GPG签名</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emg20k9.html">centos 7 上安装 testlink 1&period;9&period;15&sol;1&period;9&period;16&sol;1&period;9&period;17&sol;1&period;9&period;18 （mysql&sol;php&sol;httpd）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q44znrnq.html">select下拉列表</a>
		</li>
						<li><a href="https://www.batexi.com/a/93jy0gr8.html">linux入门  配置网络</a>
		</li>
						<li><a href="https://www.batexi.com/a/q44j6w0q.html">JavaScript&lpar;JS&rpar;计算某年某月的天数（月末）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jevxlw8.html">基于 Pymsql  数据库连接池</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/495x768z.html">Asp&period;net Boilerplate源码中NotNullAttribute的用处</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnvk28r.html">H5程序员如何利用cordova开发跨平台应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gpol97.html">golang语言构造函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/m963xy94.html">代码的坏味道（18）&mdash;&mdash;依恋情结&lpar;Feature Envy&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ko37qj.html">Hadoop学习之旅二：HDFS</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96mmn84.html">ASP&period;NET MVC学习之母版页和自定义控件的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq442nqz.html">Java中常用集合操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq44r3qz.html">C&num; Entity Framework并发处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1jl6qg.html">&lpar;转&rpar;从0开始搭建SQL Server AlwaysOn 第一篇（配置域控&plus;域用户DCADMIN）</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93v6g83.html">希尔排序&lpar;java&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
